<?php
namespace Util\Instance;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;


class Service {

    /** @return  Service */
    public static function getInstance()
    {
        return new static();
    }

    /** @return  \Service\call */
    public function getCall()
    {
        return InstanceManager::getInstance()->getService('\Service\Call');
    }

    /** @return  \Service\Attachment */
    public static function getAttachment()
    {
        return InstanceManager::getInstance()->getService('\Service\Attachment');
    }

    /** @return  \Service\Integration\INTRANETIntegration */
    public function getIntranetIntegration()
    {
        return InstanceManager::getInstance()->getService('\Service\Integration\INTRANETIntegration');
    }

    /** @return  \Service\Integration\PMIntegration */
    public static function getPmIntegration()
    {
        return InstanceManager::getInstance()->getService('\Service\Integration\PMIntegration');
    }

    /** @return  \Service\Integration\OMIntegration */
    public function getOmIntegration()
    {
        return InstanceManager::getInstance()->getService('\Service\Integration\OMIntegration');
    }

    /** @return  \Service\Integration\DEVOPSIntegration */
    public function getDevOpsIntegration()
    {
        return InstanceManager::getInstance()->getService('\Service\Integration\DEVOPSIntegration');
    }

    /** @return  \Service\CallLabels */
    public function getCallLabels()
    {
        return InstanceManager::getInstance()->getService('\Service\CallLabels');
    }

    /** @return  \Service\Teknisa\NewCode */
    public function getNewCode()
    {
        return InstanceManager::getInstance()->getService('\Service\Teknisa\NewCode');
    }

    /** @return  \Teknisa\Libs\Util\Repositories\UserData */
    public function getLibUserDataRepository()
    {
        return InstanceManager::getInstance()->getService('libUserDataRepository');
    }

    /** @return  \Service\Operador */
    public static function getOperador()
    {
        return InstanceManager::getInstance()->getService('\Service\Operador');
    }

    /** @return  \Service\CallComment */
    public static function getCallComment()
    {
        return InstanceManager::getInstance()->getService('\Service\CallComment');
    }

    /** @return  \Service\BilletIssued*/
    public static function getBilletIssued()
    {
        return InstanceManager::getInstance()->getService('\Service\BilletIssued');
    }

    /** @return \Service\Produto
     * @throws \Exception
     */
    public static function getProduto()
    {
        return InstanceManager::getInstance()->getService('\Service\Produto');
    }

    /** @return \Service\Faturamento
     * @throws \Exception
     */
    public static function getFaturamento()
    {
        return InstanceManager::getInstance()->getService('\Service\Faturamento');
    }
    
}
