<?php
namespace Teknisa\Model\Teknisa\Repositories;


class CpCallComment extends \Doctrine\ORM\EntityRepository {

    public function getCallComments($callID) {
        $query =  <<<SQL
            SELECT CC.NRCALLCOMMENT AS ID, CC.NRORG, 'Criado dia '||TO_CHAR(CC.DTINCLUSAO, 'DD/MON/YYYY')||' por '||OP.NMOPERADOR AS NAME,
                   CC.DESCRIPTION AS DESCRIPTION, TO_CHAR(CC.DTINCLUSAO, 'DD/MM/YYYY HH24:MM:SS') AS CREATED_AT
            FROM CP_CALL_COMMENT CC
            LEFT JOIN OPERADOR OP ON (OP.CDOPERADOR = CC.CDOPERINCLUSAO )
            WHERE CC.CALL = :CALL_ID
            ORDER BY CC.DTINCLUSAO DESC
SQL;

        $params = array(
            "CALL_ID" => $callID,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getSupportCallCommentsFromCRM($contatoId) {
        $query =  <<<SQL
            SELECT EV.NRSEQEVOLCONT AS ID, 'Criado dia '||TO_CHAR(EV.DTINCLUSAO, 'DD/MON/YYYY')||' por '||OP.NMOPERADOR AS NAME,
                   EV.TXEVOLCONT AS DESCRIPTION, TO_CHAR(EV.DTINCLUSAO, 'DD/MM/YYYY HH24:MM:SS') AS CREATED_AT,
                   TO_CHAR(EV.DTINCLUSAO, 'YYYYMMDDHHMISS') AS ORDERBY
            FROM EVOLCONT EV
            LEFT JOIN OPERADOR OP ON OP.CDOPERADOR = EV.CDOPEREVOL
            WHERE EV.NRSEQCONTATO = :CONTATO_ID
              AND EV.IDEVOLPUBLICO = 'S'
            ORDER BY EV.DTINCLUSAO DESC,EV.NRSEQEVOLCONT DESC
SQL;

        $params = array(
            "CONTATO_ID" => $contatoId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getProductCallCommentsFromSolicitacao($nrSoliServ, $cdClienteBase, $isTeknisaFunc)
    {
        $filter = '';
        if (!$isTeknisaFunc) {
            $filter = <<<SQL
         AND (SOL.CDCLIENTE = :cdClienteBase OR NOT(OP.CDCLIENTE = :cdClienteBase AND OPR.CDCLIENTE = :cdClienteBase))
SQL;
        }
        $query = <<<SQL
            SELECT *
              FROM (SELECT OP.NMOPERADOR||' '||LFT.TXACAOLFTRAM||' em '|| TO_CHAR(LFT.DTALFASETRAM, 'DD/MON/YYYY','NLS_LANGUAGE = BRAZILIAN PORTUGUESE') ||' e encaminhou para '||OPR.NMOPERADOR AS NAME,
                           LFT.DSALFASETRAM AS DESCRIPTION,LFT.CDFASETRAM,
                           TO_CHAR(LFT.DTALFASETRAM, 'DD/MM/YYYY HH24:MI:SS') AS CREATED_AT, TO_CHAR(LFT.DTALFASETRAM, 'YYYYMMDDHH24MISS') AS ORDERBY
                      FROM LOGFASETRAM LFT
                 LEFT JOIN OPERADOR OP  ON OP.CDOPERADOR  = LFT.CDOPERADOR
                 LEFT JOIN OPERADOR OPR ON OPR.CDOPERADOR = LFT.CDOPERRESP
                INNER JOIN SOLISERV SOL ON SOL.NRSOLISERV = :NRSOLISERV
                     WHERE LFT.NRSOLISERV = :NRSOLISERV
                       $filter
                   )
          ORDER BY ORDERBY DESC
SQL;

        $params = array(
            "NRSOLISERV" => $nrSoliServ,
            "cdClienteBase" => $cdClienteBase,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getCrmSituacao($idFrom,$idTo)
    {
        $query = <<<SQL
            SELECT NRSEQSITUACAO AS ID,DSSITUACAOCLI AS NAME
              FROM CRM_SITUACAO
             WHERE NRSEQSITUACAO IN(:IDS)
SQL;

        $params = array(
            "IDS" => array($idFrom,$idTo),
        );

        $paramTypes = array(
            'IDS' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params, $paramTypes);
    }

}
