/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_PRODMECA                                                                                               */
/* Tabela : PRODMECA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 09/11/2004 - Rafael dos Santos Lopes                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRODMECA
BEFORE INSERT OR UPDATE OR DELETE
ON PRODMECA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRME := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.VRPESOMEDI,0) <> NVL(:NEW.VRPESOMEDI,0)) THEN
         :NEW.DTULTATUPRME := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODMECA', '', 'CDPRODUTO='||:OLD.CDPRODUTO||';CDMEDICASE='||:OLD.CDMEDICASE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODMECA MODIFY DTULTATUPRME DEFAULT SYSDATE
/

