CREATE OR REPLACE TRIGGER GERA_PARAM_OPERADOR_BEFORE
BEFORE INSERT
ON OPERADOR FOR EACH ROW
DECLARE
   V_NRPARCNEGOCIO PARCNEGOCIO.NRPARCNEGOCIO%TYPE;
   V_NRPARCERIA PARCERIA.NRPARCERIA%TYPE;
   V_NRORG OPERADOR.NRORG%TYPE;
   V_CDOPERADOR PARCNEGOCIO.NRINSCRICAOPARC%TYPE;
   V_NMOPERADOR OPERADOR.NMOPERADOR%TYPE;
BEGIN
	SELECT MAX(NRPARCNEGOCIO) +1 INTO V_NRPARCNEGOCIO FROM PARCNEGOCIO;
	SELECT MAX(NRPARCERIA) +1 INTO V_NRPARCERIA FROM PARCERIA;

	V_NRORG := :NEW.NRORG;
	V_CDOPERADOR := :NEW.CDOPERADOR;
	V_NMOPERADOR := :NEW.NMOPERADOR;

	INSERT INTO PARCNEGOCIO ( NRPARCNEGOCIO, CDTIPOPARCPRINCIPAL, IDATIVO, DTINCLUSAO, CDTIPOINSCRICAO, IDPESSOAFISICA, IDINSTITUICAO, NRINSCRICAOPARC, NMPRINCIPALPARC, NMSECUNDARIPARC, NRORG) VALUES ( V_NRPARCNEGOCIO, 'OPERADOR', 'S', SYSDATE, 'CPF', 'S', 'N', V_CDOPERADOR, V_NMOPERADOR, V_NMOPERADOR, V_NRORG );

	INSERT INTO PARCERIA ( NRPARCERIA, NRPARCNEGOCIO, CDTIPOPARCEIRO, NRORG, IDATIVO, DTINCLUSAO) VALUES ( V_NRPARCERIA, V_NRPARCNEGOCIO, 'OPERADOR', V_NRORG, 'S', SYSDATE );

	:NEW.NRPARCNEGOCIO := V_NRPARCNEGOCIO;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_PARAM_OPERADOR_BEFORE','5.70.000'); END;
/

CREATE OR REPLACE TRIGGER GERA_PARAM_OPERADOR_AFTER
AFTER INSERT
ON OPERADOR FOR EACH ROW
DECLARE
   V_CDOPERADOR OPERADOR.CDOPERADOR%TYPE;
   V_NRORG OPERADOR.NRORG%TYPE;
   V_NRORGTRAB OPERADOR.NRORGTRAB%TYPE;
   V_NRESTRUTTRAB OPERADOR.NRESTRUTTRAB%TYPE;
   V_NRORGANIZACAOOPER ORGANIZACAOOPER.NRORGANIZACAOOPER%TYPE;
   V_NRESTRUTURAOPER ESTRUTURAOPER.NRESTRUTURAOPER%TYPE;
BEGIN
	V_NRORG := :NEW.NRORG;
	V_CDOPERADOR := :NEW.CDOPERADOR;
	V_NRORGTRAB := :NEW.NRORGTRAB;
	V_NRESTRUTTRAB := :NEW.NRESTRUTTRAB;

	IF(V_NRORGTRAB IS NOT NULL) THEN
		SELECT MAX(NRORGANIZACAOOPER) + 1 INTO V_NRORGANIZACAOOPER FROM ORGANIZACAOOPER;
		INSERT INTO ORGANIZACAOOPER ( NRORGANIZACAOOPER, NRORGREL, CDOPERADOR, DTINCLUSAO) VALUES(V_NRORGANIZACAOOPER, V_NRORGTRAB, V_CDOPERADOR, SYSDATE);
	END IF;

	IF (V_NRESTRUTTRAB IS NOT NULL) THEN
		SELECT MAX(NRESTRUTURAOPER) + 1	INTO V_NRESTRUTURAOPER FROM ESTRUTURAOPER;
		INSERT INTO ESTRUTURAOPER ( NRESTRUTURAOPER, NRORGANIZACAOOPER, NRESTRUTURAMREL, DTINCLUSAO) VALUES ( V_NRESTRUTURAOPER, V_NRORGANIZACAOOPER, V_NRESTRUTTRAB, SYSDATE);
	END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_PARAM_OPERADOR_AFTER','5.70.000'); END;
/