/******************************************************************************************/
/******************************************************************************************/
/*                                                                                        */
/* Trigger: DTULTATU_GRUPROMOCPRFIL                                                            */
/* Tabela : GRUPROMOCPRFIL                                                                     */
/*                                                                                        */
/* Criao:                                                                               */
/* 15/09/2008 - Leonardo Matos                                                         */
/*                                                                                        */
/******************************************************************************************/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GRUPROMOCPRFIL'  and
            type = 'TR' and
            u.uid = o.uid and
            u.name = USER)
   DROP TRIGGER DTULTATU_GRUPROMOCPRFIL
GO

CREATE TRIGGER DTULTATU_GRUPROMOCPRFIL
ON GRUPROMOCPRFIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                      (SELECT 'GRUPROMOCPRFIL', CDFILIAL, 'CDFILIAL='+CDFILIAL+
                                                          ';CDPRODPROMOCAO='+CDPRODPROMOCAO+
                                                          ';CDGRUPROMOC='+CDGRUPROMOC+';', GETDATE() FROM DELETED)
   END ELSE BEGIN
      UPDATE GRUPROMOCPRFIL
      SET DTULTATUGRPRFIL = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(GRUPROMOCPRFIL.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(GRUPROMOCPRFIL.CDPRODPROMOCAO,0) = ISNULL(INSERTED.CDPRODPROMOCAO,0)) AND
            (ISNULL(GRUPROMOCPRFIL.CDGRUPROMOC,0) = ISNULL(INSERTED.CDGRUPROMOC,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_GRUPROMOCPRFIL','5.05.023';
GO
