/******************************************************************************************/
/******************************************************************************************/
/*                                                                                        */
/* Trigger: DTULTATU_DESGRUPROMPRFIL                                                      */
/* Tabela : DESGRUPROMPRFIL                                                               */
/*                                                                                        */
/* Criao:                                                                               */
/* 10/10/2008 - Wanderson Aloisio                                                         */
/*                                                                                        */
/******************************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DESGRUPROMPRFIL'  and
            type = 'TR' and
            u.uid = o.uid and
            u.name = USER)
   DROP TRIGGER DTULTATU_DESGRUPROMPRFIL
GO

CREATE TRIGGER DTULTATU_DESGRUPROMPRFIL
ON DESGRUPROMPRFIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                      (SELECT 'DESGRUPROMPRFIL', CDFILIAL, 'CDFILIAL='+CDFILIAL+
                                                           ';CDPRODPROMOCAO='+CDPRODPROMOCAO+
                                                           ';CDGRUPROMOC='+CDGRUPROMOC+
                                                           ';CDPRODUTO='+CDPRODUTO+';', GETDATE() FROM DELETED)
   END ELSE BEGIN
      UPDATE DESGRUPROMPRFIL
      SET DTULTATUDESPRFI = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(DESGRUPROMPRFIL.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(DESGRUPROMPRFIL.CDPRODPROMOCAO,0) = ISNULL(INSERTED.CDPRODPROMOCAO,0)) AND
            (ISNULL(DESGRUPROMPRFIL.CDGRUPROMOC,0) = ISNULL(INSERTED.CDGRUPROMOC,0)) AND
            (ISNULL(DESGRUPROMPRFIL.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_DESGRUPROMPRFIL','5.05.023';
GO

