<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaEventom extends \Doctrine\ORM\EntityRepository {
    
    public function retornaEventos($nrOrg, $nrOrgPadrao, $dtCompetencia){
	
    $fpaEventom =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventom';
    $fpaEventoh =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventoh';

$sql = <<<SQL
          SELECT em, eh
    FROM $fpaEventom em 
    INNER JOIN $fpaEventoh eh WITH em.nreventom = eh.nreventom
            AND em.nrorg = eh.nrorg
            AND eh.dtmescompetenc = (SELECT MAX(ehh.dtmescompetenc) FROM $fpaEventoh ehh
                                         WHERE ehh.dtmescompetenc <= :p_dtmescompetenc
                                           AND ehh.nreventom = eh.nreventom
                                           AND ehh.nrorg = eh.nrorg)
            WHERE
            (em.nrorg = :p_nrorg or em.nrorg = :p_nrorg_padrao)
            ORDER BY em.nreventom                                           
SQL;
            $params = array(
                'p_dtmescompetenc' => $dtCompetencia,
                'p_nrorg' => $nrOrg,
                'p_nrorg_padrao' => $nrOrgPadrao
            );
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $resultado = array();
            foreach ($resultQuery as $key => $evento) {
                if($evento instanceof $fpaEventom){
                    $evento->historico = $resultQuery[$key+1];
                    $resultado[] = $evento;
                }    
            }
            return $resultado;
    }
    
    public function retornaEvento($nrEvento, $nrOrg, $nrOrgPadrao, $dtCompetencia){
	
    $fpaEventom =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventom';
    $fpaEventoh =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventoh';

$sql = <<<SQL
          SELECT em, eh
    FROM $fpaEventom em 
    INNER JOIN $fpaEventoh eh WITH em.nreventom = eh.nreventom
            AND em.nrorg = eh.nrorg
            AND eh.dtmescompetenc = (SELECT MAX(ehh.dtmescompetenc) FROM $fpaEventoh ehh
                                         WHERE ehh.dtmescompetenc <= :p_dtmescompetenc
                                           AND ehh.nreventom = eh.nreventom
                                           AND ehh.nrorg = eh.nrorg)
            WHERE
            (em.nrorg = :p_nrorg or em.nrorg = :p_nrorg_padrao) and
            em.nreventom = :p_nreventom
            ORDER BY em.nreventom                                           
SQL;
            $params = array(
                'p_dtmescompetenc' => $dtCompetencia,
                'p_nrorg' => $nrOrg,
                'p_nrorg_padrao' => $nrOrgPadrao,
                'p_nreventom' => $nrEvento
            );

            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $resultado = array();
            foreach ($resultQuery as $key => $evento) {
                if($evento instanceof $fpaEventom){
                    $evento->historico = $resultQuery[$key+1];
                    $resultado[] = $evento;
                }    
            }
            if(isset($resultado[0])) 
                return $resultado[0];
            else
                return null;
    }
    
    public function retornaListaEventosMedia($nrOrg, $nrOrgPadrao, $dtCompetencia){
	
    $fpaEventom =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventom';
    $fpaEventoh =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventoh';

$sql = <<<SQL
    SELECT em, eh
    FROM $fpaEventom em 
    INNER JOIN $fpaEventoh eh WITH em.nreventom = eh.nreventom
            AND eh.idmediaevenferi = :p_idmediaevenferi 
            AND em.nrorg = eh.nrorg
            AND eh.dtmescompetenc = (SELECT MAX(ehh.dtmescompetenc) FROM $fpaEventoh ehh
                                         WHERE ehh.dtmescompetenc <= :p_dtmescompetenc
                                           AND ehh.nreventom = eh.nreventom
                                           AND ehh.nrorg = eh.nrorg)
            WHERE
            (em.nrorg = :p_nrorg or em.nrorg = :p_nrorg_padrao)
            ORDER BY em.nreventom                                               
SQL;
            $params = array(
                'p_dtmescompetenc' => $dtCompetencia,
                'p_nrorg' => $nrOrg,
                'p_nrorg_padrao' => $nrOrgPadrao,
                'p_idmediaevenferi' => 'S'
            );
            
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $resultado = array();
            foreach ($resultQuery as $key => $evento) {
                if($evento instanceof $fpaEventom){
                    $evento->historico = $resultQuery[$key+1];
                    $resultado[] = $evento;
                }    
            }
            return $resultado;
    }
    
    public function retornaListaEventosFalta($nrOrg, $nrOrgPadrao, $idFaltasFerias, $dtCompetencia){
	
    $fpaEventom =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventom';
    $fpaEventoh =  'Teknisa\Model\Gestaopessoas\Entities\FpaEventoh';
    
$sql = <<<SQL
            SELECT em, eh
    FROM $fpaEventom em 
    INNER JOIN $fpaEventoh eh WITH em.nreventom = eh.nreventom
            AND eh.idfaltasferias IN (:idfaltasferias)
            AND em.nrorg = eh.nrorg
            AND eh.dtmescompetenc = (SELECT MAX(ehh.dtmescompetenc) FROM $fpaEventoh ehh
                                         WHERE ehh.dtmescompetenc <= :p_dtmescompetenc
                                           AND ehh.nreventom = eh.nreventom
                                           AND ehh.nrorg = eh.nrorg)
            WHERE
            (em.nrorg = :p_nrorg or em.nrorg = :p_nrorg_padrao)
            ORDER BY em.nreventom  
SQL;
            $params = array(
                'p_dtmescompetenc' => $dtCompetencia,
                'p_nrorg' => $nrOrg,
                'p_nrorg_padrao' => $nrOrgPadrao,
                'idfaltasferias' => $idFaltasFerias
            );
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $resultado = array();
            foreach ($resultQuery as $key => $evento) {
                if($evento instanceof $fpaEventom){
                    $evento->historico = $resultQuery[$key+1];
                    $resultado[] = $evento;
                }    
            }
            return $resultado;
    }
    
}