<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\Repositories;

class GpeSitufuncm extends \Doctrine\ORM\EntityRepository {
    
    public function retornaUltimoHistoricoCompetencia($nrorg, $nrorgPadrao, $nrsitufuncm, $dtmescompetenc)
    {
        $gpeSitufunch = Repositories::GPE_SITUFUNCH;
        $query = <<<SQL
SELECT a
FROM $gpeSitufunch a
WHERE (a.nrorg = :P_NRORG OR a.nrorg = :P_NRORG_PADRAO)
AND a.nrsitufuncm = :P_NRSITUFUNCM
AND a.dtefetiva = ( SELECT MAX(b.dtefetiva)
                           FROM $gpeSitufunch b
                          WHERE (a.nrorg = :P_NRORG OR a.nrorg = :P_NRORG_PADRAO)
                            AND b.nrsitufuncm = :P_NRSITUFUNCM
                            AND b.dtefetiva <= :P_DTMESCOMPETENC )
SQL;
        $params = array(
            'P_NRORG'          => $nrorg,
            'P_NRORG_PADRAO'   => $nrorgPadrao,
            'P_NRSITUFUNCM'    => $nrsitufuncm,
            'P_DTMESCOMPETENC' => $dtmescompetenc,
        );
        return current($this->getEntityManager()->createQuery($query)->execute($params));
    }
    
    public function retornaSituacaoFuncional($nrOrgPadrao, $nrOrgTrabalho, $mesCompetencia){
	
    $GpeSitufuncm =  'Teknisa\Model\Gestaopessoas\Entities\GpeSitufuncm';
    $GpeSitufunch =  'Teknisa\Model\Gestaopessoas\Entities\GpeSitufunch';

$sql = <<<SQL
    SELECT sm, sh
    FROM $GpeSitufuncm sm 
    INNER JOIN 
    $GpeSitufunch sh WITH 
    sh.dtefetiva = (
			SELECT MAX(sub.dtefetiva)
  			FROM $GpeSitufunch sub
  			WHERE sub.dtefetiva <= :p_dtmescompetenc
  			AND sh.nrorg = sub.nrorg
  			AND sh.nrsitufuncm = sub.nrsitufuncm
  			)
		AND sh.nrorg = sm.nrorg
		AND sh.nrsitufuncm = sm.nrsitufuncm    
    WHERE 
    (sm.nrorg = :p_nrorg or sm.nrorg = :p_nrorg_padrao)
SQL;
            $params = array(
                'p_dtmescompetenc' => $mesCompetencia,
                'p_nrorg' => $nrOrgTrabalho,
                'p_nrorg_padrao' => $nrOrgPadrao
            );
            
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            $resultado = array();
            foreach ($resultQuery as $key => $situ) {
                if($situ instanceof $GpeSitufuncm){
                    $situ->historico = $resultQuery[$key+1];
                    $resultado[] = $situ;
                }    
            }
            return $resultado;
    }
}